(***********************************************************************)
(*                                                                     *)
(*                                Sklml                                *)
(*                                                                     *)
(*                 The OCaml parallel skeleton system                  *)
(*                                                                     *)
(*                  projet Estime, INRIA-Rocquencourt                  *)
(*                                                                     *)
(*  Copyright 2007-2011 INRIA.                                         *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Quentin Carbonneaux <Quentin.Carbonneaux@inria.fr>                 *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: skl_extra.mli,v 1.4.2.1 2011-09-21 13:08:03 fclement Exp $ *)

val rails_same : (('a, 'b) Skl.t * int) -> ('a array, 'b array) Skl.t;;
val dup : unit -> ('a, ('a * 'a)) Skl.t;;
val projl : unit -> (('a * 'b), 'a) Skl.t;;
val projr : unit -> (('a * 'b), 'b) Skl.t;;
val injl : unit -> ('a, ('a, 'b) Skl.sum) Skl.t;;
val injr : unit -> ('b, ('a, 'b) Skl.sum) Skl.t;;
val if_then_else :
  (('a, bool) Skl.t * ('a, 'b) Skl.t * ('a, 'b) Skl.t) -> ('a, 'b) Skl.t
;;
