(***********************************************************************)
(*                                                                     *)
(*                                Sklml                                *)
(*                                                                     *)
(*                 The OCaml parallel skeleton system                  *)
(*                                                                     *)
(*                  projet Estime, INRIA-Rocquencourt                  *)
(*                                                                     *)
(*  Copyright 2007-2011 INRIA.                                         *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Quentin Carbonneaux <Quentin.Carbonneaux@inria.fr>                 *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: spawnlib.mli,v 1.16.2.1 2011-09-21 13:08:04 fclement Exp $ *)

(* Common functions, used in spawnd internally *)

open Spawnd_types;;

val noimp : unit -> 'a;;
val fail : string -> 'a;;

val maybe : 'a option -> (unit -> 'b) -> ('a -> 'b) -> 'b;;

val install_sighandlers : unit -> unit;;
val spawn_sock : (IO.ic * IO.oc -> 'a -> unit) ->
  'a -> int;;
(* val spawn_pipe : (IO.ic * IO.oc -> 'a -> unit) -> *)
(*   'a -> IO.ic * IO.oc;; *)

val request_slave : IO.ic * IO.oc -> spawn_request ->
  spawn_reply;;
val slave_loop : IO.ic * IO.oc ->
  (spawn_request -> spawn_reply) -> unit;;

type ('state, 'req) request_handler = 'req -> 'state;;
type ('state, 'req) request_generator = 'state -> 'req option;;

val master_loop : ('a, 'b) request_generator -> ('a, 'b) request_handler ->
  'a -> 'a;;
